# SPDX-FileCopyrightText: ☭ Emery Hemingway
# SPDX-License-Identifier: Unlicense

import std/[asyncdispatch, sequtils, os]
import preserves, syndicate, syndicate/capabilities

proc unixSocketPath: Unix =
  result.path = getEnv("SYNDICATE_SOCK")
  if result.path == "":
    result.path = getEnv("XDG_RUNTIME_DIR", "/run/user/1000") / "dataspace"

proc envStep: Assertion =
  var s = getEnv("SYNDICATE_STEP")
  if s != "": parsePreserves(s, Cap)
  else: capabilities.mint().toPreserve(Cap)


proc main =
  let
    step = envStep()
    label = getAppFilename().extractFilename
    data = map(commandLineParams(), parsePreserves)
  discard bootDataspace(label) do (root: Cap; turn: var Turn):
    connect(turn, unixSocketPath(), step) do (turn: var Turn; ds: Cap):
      message(turn, ds, initRecord(label, data))

  for _ in 1..4: poll()
  quit()

main()
